VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "Mscomctl.ocx"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5850
   ClientLeft      =   165
   ClientTop       =   855
   ClientWidth     =   9780
   Icon            =   "Form1.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   5850
   ScaleWidth      =   9780
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer Timer1 
      Left            =   1440
      Top             =   4320
   End
   Begin MSComctlLib.ListView lvData 
      Height          =   3375
      Index           =   0
      Left            =   360
      TabIndex        =   1
      Top             =   720
      Width           =   8775
      _ExtentX        =   15478
      _ExtentY        =   5953
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   0
   End
   Begin MSComctlLib.TabStrip tabData 
      Height          =   4095
      Left            =   0
      TabIndex        =   0
      Top             =   120
      Width           =   9495
      _ExtentX        =   16748
      _ExtentY        =   7223
      TabWidthStyle   =   2
      TabFixedWidth   =   2910
      TabMinWidth     =   2117
      _Version        =   393216
      BeginProperty Tabs {1EFB6598-857C-11D1-B16A-00C0F0283628} 
         NumTabs         =   1
         BeginProperty Tab1 {1EFB659A-857C-11D1-B16A-00C0F0283628} 
            ImageVarType    =   2
         EndProperty
      EndProperty
   End
   Begin VB.Menu mnuSettings 
      Caption         =   "Settings"
      Begin VB.Menu mnuRefresh 
         Caption         =   "Refresh rate"
         Begin VB.Menu mnuRate 
            Caption         =   "High (0.5 sec.)"
            Index           =   0
         End
         Begin VB.Menu mnuRate 
            Caption         =   "Fast (1 sec.)"
            Index           =   1
         End
         Begin VB.Menu mnuRate 
            Caption         =   "Medium (2 sec.)"
            Checked         =   -1  'True
            Index           =   2
         End
         Begin VB.Menu mnuRate 
            Caption         =   "Low (5 sec.)"
            Index           =   3
         End
         Begin VB.Menu mnuRate 
            Caption         =   "Freeze"
            Index           =   4
         End
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim IFaceCounter As String
Dim Freq(3) As Long
Dim Time_Freq As Long

Private Sub RefreshData(Optional ByVal bUpdateLists As Boolean)
   Dim pdb As PERF_DATA_BLOCK
   Dim pot() As PERF_OBJECT_TYPE
   Dim pcd() As PERF_COUNTER_DEFINITION
   Dim pid() As PERF_INSTANCE_DEFINITION
   Dim pcb() As PERF_COUNTER_BLOCK
   
   Dim nObjects As Long, nCounters As Long, nInstances As Long
   Dim lpOffset As Long, lpCntOffset As Long, lpDefOffset As Long
   Dim i As Long, j As Long, k As Long, CounterID As Long, dwSize As Long
   Dim abData() As Byte
   Dim curTemp As Currency
   Dim s As String, sTab As String
   Dim li As ListItem
   
   Static LastTime As SYSTEMTIME
   Static bTimeInit As Boolean
   Dim DeltaT As Single
   
   If Not InitCounters Then Exit Sub
   abData = GetPerfData(IFaceCounter, 500000)

   CopyMemory pdb, abData(0), Len(pdb)
   If pdb.HeaderLength = 0 Then Exit Sub
   nObjects = pdb.NumObjectTypes
   If nObjects = 0 Then Exit Sub
   
   sTab = Space(6)
   lvData(tabData.SelectedItem.Index - 1).Enabled = False
   
   If lvData.Count < nObjects Then
      bUpdateLists = True
      For i = lvData.Count To nObjects - 1
          Load lvData(i)
          lvData(i).Visible = True
      Next i
   End If
   
   If tabData.Tabs.Count < nObjects Then
      For i = tabData.Tabs.Count To nObjects - 1
          tabData.Tabs.Add
      Next i
   End If
   
   If Not bTimeInit Then
      DeltaT = Timer1.Interval / 1000
   Else
      DeltaT = (pdb.SysTime.wHour - LastTime.wHour) * 3600 + _
               (pdb.SysTime.wMinute - LastTime.wMinute) * 60 + _
               (pdb.SysTime.wSecond - LastTime.wSecond) + _
               (pdb.SysTime.wMilliseconds - LastTime.wMilliseconds) / 1000
   End If
   ReDim pot(nObjects - 1)
   lpOffset = pdb.HeaderLength
   For i = 0 To nObjects - 1
       CopyMemory pot(i), abData(lpOffset), LenB(pot(0))
       Time_Freq = pot(i).PerfFreq.LowPart
       If tabData.Tabs(i + 1).Tag = "" Then
          s = CStr(pot(i).ObjectNameTitleIndex)
          s = g_colCounters(s)
          If i = 0 Then s = s & "(s)"
          tabData.Tabs(i + 1).Caption = s
       End If
       nCounters = pot(i).NumCounters
       nInstances = pot(i).NumInstances
       If nCounters = 0 Then GoTo NextLoop
       
       ReDim pcd(nCounters - 1)
       lpCntOffset = lpOffset + pot(i).HeaderLength
       CopyMemory pcd(0), abData(lpCntOffset), Len(pcd(0)) * nCounters
       If nInstances = -1 Then
          lpDefOffset = lpOffset + pot(i).DefinitionLength
          For j = 0 To nCounters - 1
              CounterID = pcd(j).CounterNameTitleIndex
              If bUpdateLists Then
                 s = "***Unknown counter***"
                 On Error Resume Next
                 s = g_colCounters(CStr(CounterID))
                 On Error GoTo 0
                 Set li = lvData(i).ListItems.Add(, , s)
                 li.Tag = 0
              Else
                 Set li = lvData(i).ListItems(j + 1)
              End If
              dwSize = pcd(j).CounterSize
              curTemp = 0
              If dwSize > 0 Then
                 CopyMemory curTemp, abData(lpDefOffset + pcd(j).CounterOffset), dwSize
              End If
              If CCur(li.Tag) = 0 Then li.Tag = curTemp
              s = TranslateCounter(curTemp * 10000#, li.Tag * 10000#, DeltaT, dwSize, pcd(j).CounterType)
              li.Tag = curTemp
              li.SubItems(1) = s
              li.SubItems(2) = Format(curTemp * 10000#, "###,###,###,##0")
          Next j
       Else
          ReDim pid(nInstances - 1)
          ReDim pcb(nInstances - 1)
          lpDefOffset = lpOffset + pot(i).DefinitionLength
          For j = 0 To nInstances - 1
              CopyMemory pid(j), abData(lpDefOffset), Len(pid(0))
              If bUpdateLists Then
                 s = String(pid(j).NameLength, 0)
                 CopyMemory ByVal StrPtr(s), abData(lpDefOffset + pid(j).NameOffset), pid(j).NameLength
                 With lvData(i).ListItems.Add(, , TrimNull(s))
                    .Tag = ""
                    .ForeColor = vbBlue
                    .SubItems(1) = " "
                    .SubItems(2) = " "
                 End With
              End If
              lpDefOffset = lpDefOffset + pid(j).ByteLength
              For k = 0 To nCounters - 1
                  CounterID = pcd(k).CounterNameTitleIndex
                  If bUpdateLists Then
                     s = "***Unknown counter***"
                     On Error Resume Next
                     s = g_colCounters(CStr(CounterID))
                     On Error GoTo 0
                     Set li = lvData(i).ListItems.Add(, , sTab & s)
                     li.Tag = 0
                  Else
                     Set li = lvData(i).ListItems((nCounters + 1) * j + k + 2)
                  End If
                  dwSize = pcd(k).CounterSize
                  curTemp = 0
                  If dwSize > 0 Then
                     CopyMemory curTemp, abData(lpDefOffset + pcd(k).CounterOffset), dwSize
                  End If
                  If CCur(li.Tag) = 0 Then li.Tag = curTemp
                  s = TranslateCounter(curTemp * 10000#, li.Tag * 10000#, DeltaT, dwSize, pcd(k).CounterType)
                  li.Tag = curTemp
                  li.SubItems(1) = s
                  li.SubItems(2) = Format(curTemp * 10000#, "###,###,###,##0")
              Next k
              CopyMemory pcb(j), abData(lpDefOffset), Len(pcb(0))
              lpDefOffset = lpDefOffset + pcb(j).ByteLength
          Next j
       End If
NextLoop:
       lpOffset = lpOffset + pot(i).TotalByteLength
   Next i
   LastTime = pdb.SysTime
   If Not bTimeInit Then bTimeInit = True
   lvData(tabData.SelectedItem.Index - 1).Enabled = True
   On Error Resume Next
   lvData(tabData.SelectedItem.Index - 1).SetFocus
End Sub

Private Sub Form_Load()
   Caption = "Network performance monitor"
   With lvData(0)
      .View = lvwReport
      .GridLines = True
      .ColumnHeaders.Add , , "Counter name", 5700
      .ColumnHeaders.Add , , "Performance (/sec.)", 1800, 1
      .ColumnHeaders.Add , , "Absolute value", 1800, 1
      .FullRowSelect = True
      .LabelEdit = lvwManual
      .HideSelection = False
   End With
   Timer1.Interval = 2000
   If InitCounters Then
      IFaceCounter = CStr(IFaceCounterID)
      RefreshData
   End If
End Sub

Private Sub Form_Resize()
   If WindowState = vbMinimized Then Exit Sub
   Dim i As Long
   tabData.Move 0, 0, ScaleWidth, ScaleHeight
   For i = lvData.LBound To lvData.UBound
       lvData(i).Move tabData.ClientLeft, tabData.ClientTop, tabData.ClientWidth, tabData.ClientHeight
   Next i
End Sub

Private Sub Form_Unload(Cancel As Integer)
   Dim i As Long
   For i = lvData.Count - 1 To 1 Step -1
       Unload lvData(i)
   Next i
End Sub

Private Sub mnuRate_Click(Index As Integer)
   Dim i As Long
   For i = mnuRate.LBound To mnuRate.UBound
       mnuRate(i).Checked = False
   Next i
   mnuRate(Index).Checked = True
   Select Case Index
      Case 0: Timer1.Interval = 500
      Case 1: Timer1.Interval = 1000
      Case 2: Timer1.Interval = 2000
      Case 3: Timer1.Interval = 5000
   End Select
   Timer1.Enabled = (Index < 4)
End Sub

Private Sub tabData_Click()
   RefreshData
   lvData(tabData.SelectedItem.Index - 1).ZOrder
End Sub

Private Function TranslateCounter(ByVal NewVal As Variant, _
                                  ByVal LastVal As Variant, _
                                  ByVal DeltaT As Single, _
                                  ByVal cntSize As Long, _
                                  ByVal cntType As Long) As String
   Dim s As String, suffix As String
   Dim dwSize As Long, dwType As Long, dwSubType As Long
   Dim dwTimerType As Long, dwSuffix As Long
   Dim dwFreq As Long, delta As Variant
   dwSize = cntType And &H300
   If dwSize = PERF_SIZE_ZERO Then Exit Function
   dwSuffix = cntType And &H70000000
   Select Case dwSuffix
      Case PERF_DISPLAY_NO_SUFFIX: suffix = ""
      Case PERF_DISPLAY_PER_SEC:   suffix = "" '"/sec"
      Case PERF_DISPLAY_PERCENT:   suffix = "%"
      Case PERF_DISPLAY_SECONDS:   suffix = "" '" secs"
      Case PERF_DISPLAY_NOSHOW:    suffix = "" '" (hidden)"
   End Select
   dwType = cntType And &HC00
   Select Case dwType
          Case PERF_TYPE_NUMBER
               dwSubType = cntType And &H30000
               Select Case dwSubType
                  Case PERF_NUMBER_HEX      '  display as HEX value
                       TranslateCounter = "0x" & Hex(NewVal)
                  Case PERF_NUMBER_DEC_1000 '  display as a decimal/1000
                       TranslateCounter = CStr(NewVal / 1000)
                  Case PERF_NUMBER_DECIMAL '  display as a decimal
                       TranslateCounter = Format(NewVal, "###,###,###,##0")
                  Case Else                 '  display as a decimal integer
                       TranslateCounter = Format(NewVal, "###,###,###,##0")
               End Select
          Case PERF_TYPE_COUNTER
               dwSubType = cntType And &H70000
               Select Case dwSubType
                      Case PERF_COUNTER_VALUE                '  display counter value
                           TranslateCounter = Format(NewVal, "###,###,###,##0")
                      Case PERF_COUNTER_RATE                 '  divide ctr / delta time
                           dwTimerType = cntType And &H300000
                           Select Case dwTimerType
                              Case PERF_TIMER_TICK
                                   dwFreq = 1000
                              Case PERF_OBJECT_TIMER
                                   dwFreq = Time_Freq
                              Case PERF_TIMER_100NS
                                   dwFreq = 10000000
                              Case Else
                           End Select
                           If LastVal = 0 Then LastVal = NewVal
                           delta = NewVal - LastVal
                           delta = Int(delta / DeltaT / dwFreq * 100)
                           If (cntType And PERF_INVERSE_COUNTER) = PERF_INVERSE_COUNTER Then
                              delta = 100 - delta
                           End If
                           TranslateCounter = delta
'                      Case PERF_COUNTER_FRACTION             '  divide ctr / base
'                      Case PERF_COUNTER_BASE                 '  base value used in fractions
                      Case PERF_COUNTER_ELAPSED              '  subtract counter from current time
                           TranslateCounter = CDate(Time - FileTimeToVBTime(NewVal))
'                      Case PERF_COUNTER_QUEUELEN             '  Use Queuelen processing func.
'                      Case PERF_COUNTER_HISTOGRAM            '  Counter begins or ends a histogram
                      Case Else
                           TranslateCounter = CStr(NewVal)
               End Select
          Case PERF_TYPE_TEXT
          Case PERF_TYPE_ZERO
               TranslateCounter = "0": Exit Function
          Case Else
   End Select
   TranslateCounter = TranslateCounter & suffix
End Function

Private Sub Timer1_Timer()
   Timer1.Enabled = False
   RefreshData
   Timer1.Enabled = True
End Sub
