VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "Mscomctl.ocx"
Begin VB.Form frmTaskList 
   Caption         =   "Form1"
   ClientHeight    =   4860
   ClientLeft      =   165
   ClientTop       =   855
   ClientWidth     =   7005
   Icon            =   "TaskList.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   4860
   ScaleWidth      =   7005
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer Timer1 
      Left            =   600
      Top             =   4320
   End
   Begin MSComctlLib.ListView lvProcesses 
      Height          =   4095
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   6735
      _ExtentX        =   11880
      _ExtentY        =   7223
      View            =   3
      LabelEdit       =   1
      LabelWrap       =   -1  'True
      HideSelection   =   0   'False
      FullRowSelect   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   4
      BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Text            =   "Image name"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   1
         Text            =   "User name"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(3) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   2
         Text            =   "Perf"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(4) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   3
         Text            =   "Memory"
         Object.Width           =   2540
      EndProperty
   End
   Begin VB.Menu mnuView 
      Caption         =   "View"
      Begin VB.Menu mnuColumns 
         Caption         =   "Columns"
      End
      Begin VB.Menu mnuFrequency 
         Caption         =   "Refresh frequency"
         Begin VB.Menu mnuFreq 
            Caption         =   "High (1 sec)"
            Index           =   0
         End
         Begin VB.Menu mnuFreq 
            Caption         =   "Medium (5 sec)"
            Checked         =   -1  'True
            Index           =   1
         End
         Begin VB.Menu mnuFreq 
            Caption         =   "Low (10 sec)"
            Index           =   2
         End
         Begin VB.Menu mnuFreq 
            Caption         =   "Freeze"
            Index           =   3
         End
      End
   End
End
Attribute VB_Name = "frmTaskList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim Freq(3) As Long
Dim Time_Freq As Long
Private Declare Sub InitCommonControls Lib "comctl32" () 'For XP style

Public Sub RefreshView(lv As ListView, Optional bUpdateList As Boolean)
   Dim pdb As PERF_DATA_BLOCK
   Dim pot As PERF_OBJECT_TYPE
   Dim pcd() As PERF_COUNTER_DEFINITION
   Dim pid() As PERF_INSTANCE_DEFINITION
   Dim pcb() As PERF_COUNTER_BLOCK
   
   Dim nCounters As Long, nInstances As Long
   Dim lpOffset As Long, lpCntOffset As Long, lpDefOffset As Long
   Dim i As Long, j As Long, CounterId As Long, cnt As Long
   Dim abData() As Byte
   Dim sInfo As String, s As String
   Dim wdt As Long, hgt As Long, dwSize As Long, lTemp As Long, liTemp As LARGE_INTEGER, curTemp As Currency
   Dim li As ListItem
   
   Static LastVal() As Currency
   Static LastTime As SYSTEMTIME
   Static bTimeInit As Boolean
   Dim DeltaT As Single
   
   abData = GetPerfData(counters.Process)

   CopyMemory pdb, abData(0), Len(pdb)
   If (pdb.HeaderLength = 0) Or (pdb.NumObjectTypes = 0) Then Exit Sub
   
   If Not bTimeInit Then
      DeltaT = Timer1.Interval / 1000
   Else
      DeltaT = (pdb.SysTime.wHour - LastTime.wHour) * 3600 + _
               (pdb.SysTime.wMinute - LastTime.wMinute) * 60 + _
               (pdb.SysTime.wSecond - LastTime.wSecond) + _
               (pdb.SysTime.wMilliseconds - LastTime.wMilliseconds) / 1000
   End If
   lpOffset = pdb.HeaderLength
   CopyMemory pot, abData(lpOffset), LenB(pot)
   
   nCounters = pot.NumCounters
   nInstances = pot.NumInstances
   If (nCounters < 1) Or (nInstances < 1) Then Exit Sub
   
   ReDim pcd(nCounters - 1)
   ReDim pid(nInstances - 1)
   ReDim pcb(nInstances - 1)
   
   lpCntOffset = lpOffset + pot.HeaderLength
   Time_Freq = pot.PerfFreq.LowPart
   CopyMemory pcd(0), abData(lpCntOffset), Len(pcd(0)) * nCounters
   If Not frmSettings.bInitDone Then
      wdt = frmSettings.chkSettings(i).Width
      hgt = frmSettings.chkSettings(i).Height
      For j = 0 To nCounters - 1
          CounterId = pcd(j).CounterNameTitleIndex
          Load frmSettings.chkSettings(j + 1)
          frmSettings.chkSettings(j).Move Int(j / 14) * wdt + 300, (j Mod 14) * hgt * 1.5 + 300
          frmSettings.chkSettings(j + 1).Enabled = True
          frmSettings.chkSettings(j + 1).value = 0
          frmSettings.chkSettings(j + 1).Caption = g_colCounters(CStr(CounterId))
          frmSettings.chkSettings(j + 1).Tag = CounterId
          frmSettings.chkSettings(j + 1).Visible = True
      Next j
      frmSettings.bInitDone = True
   End If
   lv.Enabled = False
   If bUpdateList Then
      lv.ListItems.Clear
      lv.ColumnHeaders.Clear
      For i = 0 To frmSettings.chkSettings.Count - 1
          If frmSettings.chkSettings(i).value = 1 Then
             If i > 0 Then
                lv.ColumnHeaders.Add , , Replace(frmSettings.chkSettings(i).Caption, "%", ""), 1800, 1
             Else
                lv.ColumnHeaders.Add , , Replace(frmSettings.chkSettings(i).Caption, "%", ""), 1800
             End If
          End If
      Next i
      ReDim LastVal(1 To lv.ColumnHeaders.Count, nInstances - 1)
   End If
   lpDefOffset = lpOffset + pot.DefinitionLength
   For i = 0 To nInstances - 1
       CopyMemory pid(i), abData(lpDefOffset), Len(pid(0))
       s = String(pid(i).NameLength, 0)
       CopyMemory ByVal StrPtr(s), abData(lpDefOffset + pid(i).NameOffset), pid(i).NameLength
       lpDefOffset = lpDefOffset + pid(i).ByteLength
       
       If bUpdateList Then
          Set li = lv.ListItems.Add(, , TrimNull(s))
       Else
          If i > lv.ListItems.Count - 1 Then
             Set li = lv.ListItems.Add(, , TrimNull(s))
             ReDim LastVal(1 To lv.ColumnHeaders.Count, nInstances - 1)
          Else
             Set li = lv.ListItems(i + 1)
          End If
       End If
       If i = nInstances - 1 Then
          li.Bold = True
          li.ForeColor = vbRed
       End If
       cnt = 0
       For j = 0 To UBound(pcd)
           If frmSettings.chkSettings(j + 1).value = 1 Then
              cnt = cnt + 1
              dwSize = pcd(j).CounterSize
              curTemp = 0
              If dwSize > 0 Then
                 CopyMemory curTemp, abData(lpDefOffset + pcd(j).CounterOffset), dwSize
              End If
              s = TranslateCounter(curTemp * 10000#, LastVal(cnt, i) * 10000#, DeltaT, dwSize, pcd(j).CounterType)
              Select Case pcd(j).CounterNameTitleIndex
                 Case 56, 58, 172 To 186 'bytes
                    s = FormatByteSize(CCur(s))
                 Case 682                'priority
                    s = TranslatePriority(CLng(s))
                 Case Else
              End Select
              li.SubItems(cnt) = s
              LastVal(cnt, i) = curTemp
           End If
       Next j
       
       CopyMemory pcb(i), abData(lpDefOffset), Len(pcb(0))
       lpDefOffset = lpDefOffset + pcb(i).ByteLength
   Next i
   LastTime = pdb.SysTime
   If Not bTimeInit Then bTimeInit = True
   Set li = Nothing
   lv.Enabled = True
End Sub

Private Sub Form_Initialize()
   InitCommonControls
End Sub

Private Sub Form_Load()
   Caption = "VB process list"
   Set g_colCounters = New Collection
   Freq(0) = 1000
   Freq(1) = 5000
   Freq(2) = 10000
   Freq(3) = 0
   InitCounters
   RefreshView lvProcesses, True
   Timer1.Interval = Freq(1)
   Timer1.Enabled = True
End Sub

Private Sub Form_Resize()
   If WindowState = vbMinimized Then Exit Sub
   lvProcesses.Move 0, 0, ScaleWidth, ScaleHeight
End Sub

Private Sub Form_Unload(Cancel As Integer)
   Set g_colCounters = Nothing
   Unload frmSettings
   Set frmSettings = Nothing
End Sub

Private Sub mnuColumns_Click()
   Timer1.Enabled = False
   frmSettings.Show vbModal
   Timer1.Enabled = True
End Sub

Private Sub mnuFreq_Click(Index As Integer)
   Dim i As Long
   For i = 0 To 3
      mnuFreq(i).Checked = False
      mnuFreq(Index).Checked = True
   Next i
   Timer1.Interval = Freq(Index)
   Timer1.Enabled = (Index < 3)
End Sub

Private Sub Timer1_Timer()
   RefreshView lvProcesses
End Sub

Private Function TranslateCounter(ByVal NewVal As Variant, _
                                  ByVal LastVal As Variant, _
                                  ByVal DeltaT As Single, _
                                  ByVal cntSize As Long, _
                                  ByVal cntType As Long) As String
   Dim s As String, suffix As String
   Dim dwSize As Long, dwType As Long, dwSubType As Long
   Dim dwTimerType As Long, dwSuffix As Long
   Dim dwFreq As Long, delta As Variant
   dwSize = cntType And &H300
   If dwSize = PERF_SIZE_ZERO Then Exit Function
   dwSuffix = cntType And &H70000000
   Select Case dwSuffix
      Case PERF_DISPLAY_NO_SUFFIX: suffix = ""
      Case PERF_DISPLAY_PER_SEC:   suffix = "" '"/sec"
      Case PERF_DISPLAY_PERCENT:   suffix = "%"
      Case PERF_DISPLAY_SECONDS:   suffix = "" '" secs"
      Case PERF_DISPLAY_NOSHOW:    suffix = "" '" (hidden)"
   End Select
   dwType = cntType And &HC00
   Select Case dwType
          Case PERF_TYPE_NUMBER
               dwSubType = cntType And &H30000
               Select Case dwSubType
                  Case PERF_NUMBER_HEX      '  display as HEX value
                       TranslateCounter = "0x" & Hex(NewVal)
                  Case PERF_NUMBER_DEC_1000 '  display as a decimal/1000
                       TranslateCounter = CStr(NewVal / 1000)
                  Case PERF_NUMBER_DECIMAL '  display as a decimal
                       TranslateCounter = CStr(NewVal)
                  Case Else                 '  display as a decimal integer
                       TranslateCounter = CStr(NewVal)
               End Select
          Case PERF_TYPE_COUNTER
               dwSubType = cntType And &H70000
               Select Case dwSubType
                      Case PERF_COUNTER_VALUE                '  display counter value
                           TranslateCounter = CStr(NewVal)
                      Case PERF_COUNTER_RATE                 '  divide ctr / delta time
                           dwTimerType = cntType And &H300000
                           Select Case dwTimerType
                              Case PERF_TIMER_TICK
                                   dwFreq = 1000
                              Case PERF_OBJECT_TIMER
                                   dwFreq = Time_Freq
                              Case PERF_TIMER_100NS
                                   dwFreq = 10000000
                              Case Else
                           End Select
                           If LastVal = 0 Then LastVal = NewVal
                           delta = NewVal - LastVal
                           delta = Int(delta / DeltaT / dwFreq * 100)
                           If (cntType And PERF_INVERSE_COUNTER) = PERF_INVERSE_COUNTER Then
                              delta = 100 - delta
                           End If
                           TranslateCounter = delta
                      Case PERF_COUNTER_FRACTION             '  divide ctr / base
                      Case PERF_COUNTER_BASE                 '  base value used in fractions
                      Case PERF_COUNTER_ELAPSED              '  subtract counter from current time
                           TranslateCounter = CDate(Time - FileTimeToVBTime(NewVal))
                      Case PERF_COUNTER_QUEUELEN             '  Use Queuelen processing func.
                      Case PERF_COUNTER_HISTOGRAM            '  Counter begins or ends a histogram
                      Case Else
               End Select
          Case PERF_TYPE_TEXT
          Case PERF_TYPE_ZERO
               TranslateCounter = "0": Exit Function
   End Select
   TranslateCounter = TranslateCounter & suffix
End Function

Private Function TranslatePriority(ByVal priority As Long) As String
   Dim s As String
   Select Case priority
       Case 0:        s = "Unknown"
       Case 1:        s = "Idle"
       Case 2 To 4:   s = "Low"
       Case 5 To 7:   s = "Below normal"
       Case 8 To 10:  s = "Normal"
       Case 11, 12:   s = "Above normal"
       Case 13 To 20: s = "High"
       Case Else:     s = "Real time"
   End Select
   s = s & " (" & CStr(priority) & ")"
   TranslatePriority = s
End Function
