Attribute VB_Name = "mPerf"
Option Explicit

Dim bInit As Boolean
Public IFaceCounterID As Long
Public g_colCounters As Collection

Public Function InitCounters(Optional bForce As Boolean) As Boolean
   If bForce Then bInit = False
   If bInit Then
      InitCounters = True
      Exit Function
   End If
   Dim hKey As Long, lType As Long, dwSize As Long, ret As Long, i As Long
   Dim abData() As Byte
   Dim s As String
   Dim sVal() As String
   
   ret = RegOpenKeyEx(HKEY_LOCAL_MACHINE, PerfLibKey, 0, KEY_READ, hKey)
   If hKey = 0 Then Exit Function
   
   RegQueryValueEx hKey, "Counter", 0, lType, 0, dwSize
   If dwSize Then
      ReDim abData(dwSize - 1)
      RegQueryValueEx hKey, "Counter", 0, lType, abData(0), dwSize
      s = StrConv(abData, vbUnicode)
      sVal = Split(s, Chr(0))
      Set g_colCounters = Nothing
      Set g_colCounters = New Collection
      For i = 2 To UBound(sVal) - 2 Step 2
          g_colCounters.Add sVal(i + 1), sVal(i)
          If LCase(sVal(i + 1)) = "network interface" Then IFaceCounterID = CLng(sVal(i))
      Next i
   End If
   RegCloseKey hKey
   InitCounters = True
End Function

Public Function GetPerfData(ByVal idx As Long, _
                            Optional ByVal dwGrow As Long = 100000) As Byte()
   
   Dim hKey As Long, lType As Long, dwSize As Long, ret As Long
   Dim abData() As Byte
   ReDim abData(0)
   lType = REG_BINARY
   
   Do While RegQueryValueEx(HKEY_PERFORMANCE_DATA, CStr(idx), 0, lType, abData(0), dwSize) = ERROR_MORE_DATA
      dwSize = dwSize + dwGrow
      ReDim abData(dwSize - 1)
      If dwSize > 1000000 Then Exit Do
   Loop
   Call RegCloseKey(HKEY_PERFORMANCE_DATA)
   GetPerfData = abData
   Erase abData
End Function

