VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "Mscomctl.ocx"
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Form1"
   ClientHeight    =   5640
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   11325
   Icon            =   "Form1.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5640
   ScaleWidth      =   11325
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame Frame3 
      Caption         =   "Description"
      Height          =   2415
      Left            =   4320
      TabIndex        =   6
      Top             =   3120
      Width           =   6855
      Begin VB.TextBox Text1 
         Height          =   2055
         Left            =   120
         Locked          =   -1  'True
         MultiLine       =   -1  'True
         ScrollBars      =   2  'Vertical
         TabIndex        =   7
         Top             =   240
         Width           =   6615
      End
   End
   Begin VB.Frame Frame2 
      Caption         =   "Info"
      Height          =   2895
      Left            =   4320
      TabIndex        =   3
      Top             =   120
      Width           =   6855
      Begin VB.ListBox List2 
         Height          =   2205
         Left            =   120
         TabIndex        =   5
         Top             =   480
         Width           =   6615
      End
      Begin VB.Label Label4 
         Caption         =   "Label4"
         Height          =   255
         Left            =   120
         TabIndex        =   4
         Top             =   240
         Width           =   1695
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Counters"
      Height          =   5415
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   4095
      Begin VB.ListBox List1 
         Height          =   4545
         Left            =   240
         Sorted          =   -1  'True
         TabIndex        =   2
         Top             =   600
         Width           =   3615
      End
      Begin MSComctlLib.TabStrip TabStrip1 
         Height          =   5055
         Left            =   120
         TabIndex        =   1
         Top             =   240
         Width           =   3855
         _ExtentX        =   6800
         _ExtentY        =   8916
         _Version        =   393216
         BeginProperty Tabs {1EFB6598-857C-11D1-B16A-00C0F0283628} 
            NumTabs         =   3
            BeginProperty Tab1 {1EFB659A-857C-11D1-B16A-00C0F0283628} 
               Caption         =   "All"
               ImageVarType    =   2
            EndProperty
            BeginProperty Tab2 {1EFB659A-857C-11D1-B16A-00C0F0283628} 
               Caption         =   "Global"
               ImageVarType    =   2
            EndProperty
            BeginProperty Tab3 {1EFB659A-857C-11D1-B16A-00C0F0283628} 
               Caption         =   "Costly"
               ImageVarType    =   2
            EndProperty
         EndProperty
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Declare Sub InitCommonControls Lib "comctl32" ()

Dim m_colHelp As Collection
Dim m_colCounters As Collection

Private Sub Form_Initialize()
   InitCommonControls
End Sub

Private Sub Form_Load()
   Caption = "Performance counters demo"
   EnableDebugPrivNT
   TabStrip1.Tabs(1).Selected = True
End Sub

Private Sub Form_Unload(Cancel As Integer)
   Set m_colCounters = Nothing
   Set m_colHelp = Nothing
End Sub

Private Sub List1_Click()
   Label4 = ""
   ShowDescription List1.ItemData(List1.ListIndex)
   ShowPerfData List1.ItemData(List1.ListIndex)
End Sub

Private Sub List2_Click()
   If List2.ItemData(List2.ListIndex) Then
      ShowDescription List2.ItemData(List2.ListIndex)
   End If
End Sub

Private Sub ShowCounters(ByVal idx As Long)
   Dim i As Long
   List1.Clear
   List2.Clear
   Text1.Text = ""
   Label4.Caption = ""
   Refresh
   MousePointer = vbHourglass
   Select Case idx
      Case 0
         InitAllCounters m_colCounters, m_colHelp
         For i = 0 To UBound(pdAll)
             List1.AddItem "[" & ZeroPad(pdAll(i).CounterId, 4) & "] " & pdAll(i).CounterName
             List1.ItemData(List1.NewIndex) = pdAll(i).CounterId
         Next i
      Case 1
         InitGlobalCounters m_colCounters
         For i = 0 To UBound(pdGlobal)
             List1.AddItem "[" & ZeroPad(pdGlobal(i).CounterId, 4) & "] " & pdGlobal(i).CounterName
             List1.ItemData(List1.NewIndex) = pdGlobal(i).CounterId
         Next i
      Case 2
         InitCostlyCounters m_colCounters
         For i = 0 To UBound(pdCostly)
             List1.AddItem "[" & ZeroPad(pdCostly(i).CounterId, 4) & "] " & pdCostly(i).CounterName
             List1.ItemData(List1.NewIndex) = pdCostly(i).CounterId
         Next i
   End Select
   List1.Refresh
   If List1.ListCount Then List1.ListIndex = 0
   MousePointer = vbDefault
End Sub

Private Sub ShowDescription(ByVal idx As Long)
   Text1.Text = "[CounterID = " & idx & "]" & vbCrLf
   s = "No description"
   On Error Resume Next
   s = m_colHelp(CStr(idx))
   Text1.Text = Text1.Text & s
   On Error GoTo 0
End Sub

Private Sub ShowPerfData(ByVal idx As Long)
   Dim pdb As PERF_DATA_BLOCK
   Dim pot() As PERF_OBJECT_TYPE
   Dim pcd() As PERF_COUNTER_DEFINITION
   Dim pid() As PERF_INSTANCE_DEFINITION
   Dim pcb() As PERF_COUNTER_BLOCK
   
   Dim nObjects As Long, nCounters As Long, nInstances As Long
   Dim lpOffset As Long, lpCntOffset As Long, lpDefOffset As Long
   Dim i As Long, j As Long, CounterId As Long
   Dim abData() As Byte
   Dim s As String
   
   abData = GetPerfData(CStr(idx), 500000)

   CopyMemory pdb, abData(0), Len(pdb)
   If pdb.HeaderLength = 0 Then Exit Sub
   nObjects = pdb.NumObjectTypes
   Label4 = "Objects count: " & nObjects
   List2.Clear
   If nObjects = 0 Then Exit Sub
   ReDim pot(nObjects - 1)
   lpOffset = pdb.HeaderLength
   For i = 0 To nObjects - 1
       If List2.ListCount Then List2.AddItem String(20, "=")
       CopyMemory pot(i), abData(lpOffset), LenB(pot(0))
       s = CStr(pot(i).ObjectNameTitleIndex)
       On Error Resume Next
       s = m_colCounters(s)
       If Err Then s = "Counter ID = " & s
       On Error GoTo 0
       List2.AddItem "Object " & i + 1 & " [" & s & "]:"
       List2.ItemData(List2.NewIndex) = pot(i).ObjectNameTitleIndex
       nCounters = pot(i).NumCounters
       List2.AddItem "   Counters available [" & nCounters & "]:"
       nInstances = pot(i).NumInstances
       If nCounters Then
          ReDim pcd(nCounters - 1)
          lpCntOffset = lpOffset + pot(i).HeaderLength
          CopyMemory pcd(0), abData(lpCntOffset), Len(pcd(0)) * nCounters
          If nInstances > 0 Then
             ReDim pid(nInstances - 1)
             ReDim pcb(nInstances - 1)
          Else
             ReDim pcb(0)
          End If
          For j = 0 To nCounters - 1
             CounterId = pcd(j).CounterNameTitleIndex
             s = "***Unknown counter***"
             On Error Resume Next
             s = m_colCounters(CStr(CounterId))
             On Error GoTo 0
             List2.AddItem vbTab & "[" & CounterId & "]: " & vbTab & s
             List2.ItemData(List2.NewIndex) = pcd(j).CounterNameTitleIndex
          Next j
          List2.AddItem "    Object Instances [" & IIf(nInstances > -1, nInstances, "None") & "]:"
          lpDefOffset = lpOffset + pot(i).DefinitionLength
          For j = 0 To nInstances - 1
             CopyMemory pid(j), abData(lpDefOffset), Len(pid(0))
             s = String(pid(j).NameLength, 0)
             CopyMemory ByVal StrPtr(s), abData(lpDefOffset + pid(j).NameOffset), pid(j).NameLength
             List2.AddItem vbTab & TrimNull(s)
             lpDefOffset = lpDefOffset + pid(j).ByteLength
             CopyMemory pcb(j), abData(lpDefOffset), Len(pcb(0))
             lpDefOffset = lpDefOffset + pcb(j).ByteLength
          Next j
       End If
       lpOffset = lpOffset + pot(i).TotalByteLength
   Next i
   Me.Show
End Sub

Private Sub TabStrip1_Click()
   If m_colCounters Is Nothing Then
      InitAllCounters m_colCounters, m_colHelp
   End If
   ShowCounters TabStrip1.SelectedItem.Index - 1
End Sub
