Attribute VB_Name = "mRegistry"
Public Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Public Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Public Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long

Public Const HKEY_LOCAL_MACHINE As Long = &H80000002
Public Const HKEY_PERFORMANCE_DATA As Long = &H80000004

Public Const ERROR_SUCCESS       As Long = 0
Public Const ERROR_ACCESS_DENIED As Long = 5
Public Const ERROR_MORE_DATA     As Long = 234
Public Const ERROR_NO_MORE_ITEMS As Long = 259

Public Const STANDARD_RIGHTS_ALL = &H1F0000
Public Const KEY_QUERY_VALUE = &H1
Public Const KEY_SET_VALUE = &H2
Public Const KEY_CREATE_SUB_KEY = &H4
Public Const KEY_ENUMERATE_SUB_KEYS = &H8
Public Const KEY_NOTIFY = &H10
Public Const KEY_CREATE_LINK = &H20
Public Const SYNCHRONIZE = &H100000
Public Const KEY_ALL_ACCESS = ((STANDARD_RIGHTS_ALL _
                             Or KEY_QUERY_VALUE _
                             Or KEY_SET_VALUE _
                             Or KEY_CREATE_SUB_KEY _
                             Or KEY_ENUMERATE_SUB_KEYS _
                             Or KEY_NOTIFY Or KEY_CREATE_LINK) _
                           And (Not SYNCHRONIZE))
Public Const KEY_READ = &H20019  ' ((READ_CONTROL Or KEY_QUERY_VALUE Or
                                 ' KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY)
                                 ' And (Not SYNCHRONIZE))

Public Const REG_NONE As Long = 0                     ' No data
Public Const REG_SZ As Long = 1                       ' nul terminated string
Public Const REG_EXPAND_SZ As Long = 2                ' nul terminated string w/enviornment var
Public Const REG_BINARY As Long = 3                   ' Free form binary
Public Const REG_DWORD As Long = 4                    ' 32-bit number
Public Const REG_DWORD_LITTLE_ENDIAN As Long = 4      ' 32-bit number (same as REG_DWORD)
Public Const REG_DWORD_BIG_ENDIAN As Long = 5         ' 32-bit number
Public Const REG_LINK As Long = 6                     ' Symbolic Link (unicode)
Public Const REG_MULTI_SZ As Long = 7                 ' Multiple Unicode strings
Public Const REG_RESOURCE_LIST As Long = 8            ' Resource list in the resource map
Public Const REG_FULL_RESOURCE_DESCRIPTOR As Long = 9 ' Resource list in the hardware description
Public Const REG_RESOURCE_REQUIREMENTS_LIST As Long = 10
